#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <locale.h>
#include <wchar.h>

int main(int argc, char *argv[]) {
	size_t len, wclen;
	int converted;
	// The non-ascii characters in hexadecimal notation: "Hello,
	//  \xe4\xb8\x96\xe7\x95\x8c!\n"
	const char *helloworld = "Hello, 世界!\n";
	const char *ch;
	wchar_t helloworldwc[12];
	wchar_t *wcchar;

	// This call is needed to set up the environment.
	setlocale(LC_ALL, "");

	// Getting the string length.
	len = strlen(helloworld);
	wprintf(L"strlen: %lu\n", len);

	converted = 0;
	wcchar = helloworldwc;
	for (ch = helloworld; *ch; ch += converted) {
			// Use the mbtowc function to convert the
			// multibyte-string into the wide-char string.
			converted = mbtowc(wcchar, ch, 4);
			wprintf(L"Bytes converted: %i\n", converted);
			wcchar++;
  }
	*wcchar = '\0';

	wclen = wcslen(helloworldwc);
	wprintf(L"wclen: %lu\n", wclen);
	const char *end;
	for (wcchar = helloworldwc; *wcchar; wcchar++) {
			wprintf(L"dec: %i / hex: ", *wcchar);
			ch = (char *)wcchar;
			for (end = (ch + 3); ch <= end; ch++) {
					wprintf(L"%2X", *ch);
			}
			wprintf(L"\n");
	}

	return 0;
}
